typedef LONG NTSTATUS, *PNTSTATUS;

typedef struct _UNICODE_STRING
{
  USHORT Length;
  USHORT MaximumLength;
  PWSTR Buffer;
} UNICODE_STRING, *PUNICODE_STRING;

#define NT_SUCCESS(StatCode)  ((NTSTATUS)(StatCode) == 0)

#define SECTORSIZE 512


#pragma pack(push,1)

typedef struct _FAT32_BOOT_SECTOR
{
  unsigned char  magic0;                      // 0
  unsigned char  res0;                        // 1
  unsigned char  magic1;                      // 2
//  unsigned char  Magic[3];                    // 0
  unsigned char  OEMName[8];                  // 3
  unsigned short BytesPerSector;              // 11
  unsigned char  SectorsPerCluster;           // 13
  unsigned short ReservedSectors;             // 14
  unsigned char  FATCount;                    // 16
  unsigned short RootEntries;                 // 17
  unsigned short Sectors;                     // 19
  unsigned char  Media;                       // 21
  unsigned short FATSectors;                  // 22
  unsigned short SectorsPerTrack;             // 24
  unsigned short Heads;                       // 26
  unsigned long  HiddenSectors;               // 28
  unsigned long  SectorsHuge;                 // 32
  unsigned long  FATSectors32;                // 36
  unsigned short ExtFlag;                     // 40
  unsigned short FSVersion;                   // 42
  unsigned long  RootCluster;                 // 44
  unsigned short FSInfoSector;                // 48
  unsigned short BootBackup;                  // 50
  unsigned char  Res3[12];                    // 52
  unsigned char  Drive;                       // 64
  unsigned char  Res4;                        // 65
  unsigned char  ExtBootSignature;            // 66
  unsigned long  VolumeID;                    // 67
  unsigned char  VolumeLabel[11];             // 71
  unsigned char  SysType[8];                  // 82
  unsigned char  Res2[420];                   // 90
  unsigned short  Signature1;                  // 510
} FAT32_BOOT_SECTOR, *PFAT32_BOOT_SECTOR;
//} __attribute__((packed)) FAT32_BOOT_SECTOR, *PFAT32_BOOT_SECTOR;

#pragma pack(pop)

#pragma pack(push,1)

typedef struct _FAT32_FSINFO
{
  unsigned long  LeadSig;          // 0
  unsigned char  Res1[480];        // 4
  unsigned long  StrucSig;         // 484
  unsigned long  FreeCount;        // 488
  unsigned long  NextFree;         // 492
  unsigned long  Res2[3];          // 496
  unsigned long  TrailSig;         // 508
} FAT32_FSINFO, *PFAT32_FSINFO;
//} __attribute__((packed)) FAT32_FSINFO, *PFAT32_FSINFO;

#pragma pack(pop)

//void Fat32Format (HANDLE  FileHandle,
//	     PPARTITION_INFORMATION  PartitionInfo,
//	     PDISK_GEOMETRY DiskGeometry,
//	     BOOL  QuickFormat,
//	     DWORD  ClusterSize);

